﻿Option Strict On
Imports System.Windows.Media.Imaging
Imports Microsoft.Phone
Imports System.IO.IsolatedStorage
Imports System.IO
Imports System.Xml.Linq
Imports Microsoft.Devices
Imports Microsoft.Expression.Interactivity.Layout

Public Class ImageDataInfo
    Property image As String
End Class

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Dim kanjiIndex As Integer
    Dim imageByte As Byte()
    Dim myCamera As PhotoCamera
    Dim bufferValue As Integer = 5119

    Dim imageFileName As String
    Dim recordDate As String
    Dim imageSource As WriteableBitmap
 
    Dim myImage As Image
    Dim imageList As New List(Of Image)

    Dim myImageInfo As New List(Of ImageDataInfo)

    Dim xmldoc As XElement
    Dim positionX As Double
    Dim positionY As Double

    Dim starPositionX As Double
    Dim starPositionY As Double

    Dim myAngle As Integer = 0
    Dim starMyAngle As Integer = 0
    Shared myIndex As Integer = 0

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.DirectoryExists("AddingIconCamera") = False Then
            storage.CreateDirectory("AddingIconCamera")
        End If

        Dim xmlFilePath As String = Path.Combine("AddingIconCamera", "ImageList.xml")
        If storage.FileExists(xmlFilePath) = True Then
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = True
        Else
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = False
        End If
        myCamera = New PhotoCamera
        myVideoBrush.SetSource(myCamera)


        AddHandler myCamera.Initialized, Sub(cameraSender As Object, cameraArgs As CameraOperationCompletedEventArgs)
                                             Try
                                                 If cameraArgs.Succeeded = False Then
                                                     Exit Sub
                                                 Else
                                                     myCamera.FlashMode = FlashMode.Auto
                                                     Dim myResolution As IEnumerable(Of Size) = myCamera.AvailableResolutions
                                                     myCamera.Resolution = myResolution.First
                                                 End If
                                             Catch
                                                 Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                                                               MessageBox.Show("カメラがスタートするまでお待ちください。")
                                                                                           End Sub)

                                             End Try

                                         End Sub
        AddHandler myCamera.CaptureImageAvailable, AddressOf myCamera_CaptureImageAvailable

    End Sub

    Private Sub myCamera_CaptureImageAvailable(sender As Object, e As ContentReadyEventArgs)
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication

        Dim filePath As String = Path.Combine("AddingIconCamera", imageFileName)
        Dim xmlFilePath As String = Path.Combine("AddingIconCamera", "ImageList.xml")



        Using myStream As IsolatedStorageFileStream = storage.CreateFile(filePath)
            Dim myBuffer(bufferValue) As Byte
            Dim myByteRead As Integer = -1
            Do
                myByteRead = e.ImageStream.Read(myBuffer, 0, myBuffer.Length)
                myStream.Write(myBuffer, 0, myByteRead)
            Loop While (myByteRead > 0)
            e.ImageStream.Close()
        End Using

        Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                      Dim imageStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                                                      Using stream As IsolatedStorageFileStream = imageStorage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                                                          Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(stream)
                                                          dummyImage.Source = imageSource
                                                      End Using


                                                      Dim myWriteableBitmap As WriteableBitmap
                                                      myWriteableBitmap = New WriteableBitmap(InkPresenter1, Nothing)

                                                      If imageStorage.FileExists(Path.Combine("AddingIconCamera", imageFileName)) = True Then
                                                          imageStorage.DeleteFile(Path.Combine("AddingIconCamera", imageFileName))
                                                      End If

                                                      Using Stream As IsolatedStorageFileStream = storage.CreateFile(Path.Combine("AddingIconCamera", imageFileName))
                                                          System.Windows.Media.Imaging.Extensions.SaveJpeg(myWriteableBitmap, Stream, 480, 640, 0, 85)
                                                      End Using
                                                  End Sub)



        'XMLファイルの保存
        Dim xmlStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication

        If xmlStorage.FileExists(xmlFilePath) = False Then
            Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                      <PhotoBooth>
                                          <Picture RecordDate=<%= recordDate %>>
                                              <ImageName><%= imageFileName %></ImageName>
                                          </Picture>
                                      </PhotoBooth>
            Using xmlStream As IsolatedStorageFileStream = xmlStorage.CreateFile(xmlFilePath)
            End Using


            If xmlStorage.FileExists(xmlFilePath) = True Then
                Using xmlwriter As StreamWriter = New StreamWriter(xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write), System.Text.Encoding.UTF8)
                    xmlwriter.Flush()
                    xmlwriter.Write(xmldoc.ToString)
                End Using
                Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                              MessageBox.Show("画像とXMLファイルを保存しました。")
                                                              dummyImage.Source = Nothing
                                                              dummyImage.Visibility = Windows.Visibility.Collapsed
                                                              IchiranShow()
                                                          End Sub)


            End If
        Else
            Dim xmlStream As IsolatedStorageFileStream = xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Read)
            Using xmlreader As StreamReader = New StreamReader(xmlStream)

                Dim readXmldoc As String = xmlreader.ReadToEnd
                Dim doc As XElement = XElement.Parse(readXmldoc)
                Dim addXml As XElement = <Picture RecordDate=<%= recordDate %>>
                                             <ImageName><%= imageFileName %></ImageName>
                                         </Picture>
                doc.Add(addXml)
                xmlStream.Close()

                If xmlStorage.FileExists(xmlFilePath) = True Then
                    Using xmlwriter As StreamWriter = New StreamWriter(storage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write), System.Text.Encoding.UTF8)
                        xmlwriter.Flush()
                        xmlwriter.Write(doc.ToString)
                        Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                                      dummyImage.Source = Nothing
                                                                      dummyImage.Visibility = Windows.Visibility.Collapsed
                                                                      MessageBox.Show("画像とXMLファイルを保存しました。")
                                                                      IchiranShow()
                                                                  End Sub)
                    End Using

                End If
            End Using
        End If
    End Sub

    Private Sub IchiranShow()
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("AddingIconCamera", "ImageList.xml")
        If storage.FileExists(filePath) = True Then
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = True
        Else
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = False
        End If
    End Sub

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        xmldoc = XElement.Load("kanji.xml")
        For Each result In From c In xmldoc.Descendants("image") Select c
            myImageInfo.Add(New ImageDataInfo With {.image = "Image/" & result.Value})
        Next
        ListBox1.ItemsSource = myImageInfo
    End Sub

    Private Sub CameraGo(sender As Object, e As EventArgs)
        If myCamera Is Nothing = False Then
            Try
                dummyImage.Visibility = Windows.Visibility.Visible
                imageFileName = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"
                recordDate = DateTime.Now.ToString("yyyy/MM/dd/HH:mm:ss")
                myCamera.CaptureImage()
            Catch
                Me.Dispatcher.BeginInvoke(Sub() MessageBox.Show("エラーが発生しましたが、データは保存されています。"))
            End Try
        End If
    End Sub

    Private Sub ListGo(sender As Object, e As EventArgs)
        NavigationService.Navigate(New Uri("/DataIchiranPage.xaml", UriKind.Relative))
    End Sub

    Private Sub ClearGo(sender As Object, e As EventArgs)
        For i As Integer = 0 To imageList.Count - 1
            Inkpresenter1.Children.Remove(imageList(i))
        Next
    End Sub

    Private Sub ListBox1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox1.SelectionChanged
        kanjiIndex = ListBox1.SelectedIndex
    End Sub

    Private Sub Inkpresenter1_DoubleTap(sender As Object, e As System.Windows.Input.GestureEventArgs) Handles Inkpresenter1.DoubleTap
        If kanjiIndex < 0 Then
            MessageBox.Show("漢字画像を選択してください。")
            Exit Sub
        End If
        Dim behavior As New MouseDragElementBehavior
        Dim kanjiName As String = xmldoc.Descendants("image")(kanjiIndex).Value
        myImage = New Image
        positionX = e.GetPosition(Inkpresenter1).X
        positionY = e.GetPosition(InkPresenter1).Y

        With myImage
            .Width = 100
            .Height = 100
            .SetValue(Canvas.LeftProperty, positionX - 50)
            .SetValue(Canvas.TopProperty, positionY - 50)
            .Source = New BitmapImage(New Uri("Image/" & kanjiName, UriKind.Relative))
            .Tag = myIndex
        End With
            myIndex = myIndex + 1
            InkPresenter1.Children.Add(myImage)
            imageList.Add(myImage)

            'Dim myGesture = GestureService.GetGestureListener(myImage)
            AddHandler myImage.Tap, Sub(imageSender As Object, imageArgs As System.Windows.Input.GestureEventArgs)
                                        Dim tapPositionX = imageArgs.GetPosition(InkPresenter1).X
                                        Dim tapPositionY = imageArgs.GetPosition(InkPresenter1).Y
                                        Dim no As Integer = CInt(DirectCast(imageSender, Image).Tag)

                                        imageList(no).SetValue((Canvas.LeftProperty), tapPositionX - 50)
                                        imageList(no).SetValue((Canvas.TopProperty), tapPositionY - 50)

                                        Dim myComposite As New CompositeTransform
                                        myComposite.CenterX = 50
                                        myComposite.CenterY = 50
                                        If myAngle > 360 Then myAngle = 0
                                        myAngle = myAngle + 45
                                        myComposite.Rotation = myAngle

                                        imageList(no).RenderTransform = myComposite
                                    End Sub
        behavior.Attach(myImage)
    End Sub

    Protected Overrides Sub OnNavigatingFrom(e As System.Windows.Navigation.NavigatingCancelEventArgs)
        myIndex = 0
        myCamera = Nothing
        MyBase.OnNavigatingFrom(e)
    End Sub

  
End Class
